{
  Soutezici cislo 13
  Kategorie starsi zaci
}

unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, ComCtrls, StdCtrls, CheckLst;

type
  TForm1 = class(TForm)
    Open: TOpenDialog;
    mesta: TListBox;
    posX: TListBox;
    posY: TListBox;
    Cesty: TImage;
    StaticText1: TStaticText;
    StaticText2: TStaticText;
    StaticText3: TStaticText;
    cestaz: TListBox;
    Label1: TLabel;
    cestado: TListBox;
    Label2: TLabel;
    Label3: TLabel;
    cestavzdalenost: TListBox;
    cestarychlost: TListBox;
    Label4: TLabel;
    Debug: TStaticText;
    CheckBox1: TCheckBox;
    Mapa: TImage;
    CheckBox2: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

// funkce vracici pozici mesta X
function PoziceMestaX(mesto : string) : integer;
var
  odpoved, x : integer;
begin
  for x:= 0 to Form1.mesta.Count do
  begin
    if (mesto = form1.mesta.Items[x]) then
    begin
      result := strtoint(form1.posX.Items[x]);
      break;
    end;
  end;
end;

// funkce vracici pozici mesta Y
function PoziceMestaY(mesto : string) : integer;
var
  odpoved, x : integer;
begin
  for x:= 0 to Form1.mesta.Count do
  begin
    if (mesto = form1.mesta.Items[x]) then
    begin
      result := strtoint(form1.posY.Items[x]);
      break;
    end;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  soubor: file;
  buff: array[0..1000000] of Char;
  nacteno, cyklus: integer;
  konec: boolean;
  radek,obsah : string;
  pozice: int64;
  temp1, temp2 : integer;
  aktualne : integer;
  aktualnecesta : integer;
begin
   Mapa.Canvas.Create;
   Cesty.Canvas.Create;
   Cesty.Canvas.Brush.Color := clRed;

   If (Open.Execute) then
   begin
      // nastavi zakladni hodnoty promennych
      konec := false;
      pozice := 1;
      aktualne := 0;
      aktualnecesta := 0;
      // vybere soubor a necite z nej data
      AssignFile(soubor,Open.FileName);
      Reset(soubor,1);
      // samotne nacitani
    repeat
      BlockRead(soubor,buff,1000000,nacteno);
      Seek(soubor,pozice);

      // hlida si ukonceni podle toho, kolik nacetl dat v predchozim nacitani
      if (nacteno < 1000000) then begin konec:=true end;

      // vynuluje radky a zacina cist data ze souboru z bufferu po jednotlivych
      // znacich a sklada z nich retezce. kazdy tento retezec konci koncem radky
      // ulozi si pozici, kde skoncil radek a pak se vraci s nacitanim tam, kde
      // skoncil. jednotlive radky zpracovava a vzdy poslednim udajem  jednotlivych
      // tagu zakonci vykreslenim udaje

      radek := '';
      for cyklus := 0 to nacteno do
      begin
          // new line
           if (buff[cyklus] = char(13)) then
           begin
            pozice := pozice + cyklus;

            // TATO CAST URCUJE POZICE A JMENA MEST
            temp1 := pos('<nazev>',radek);
            if (temp1 > 0) then
            begin
              temp2 := pos('</nazev>',radek);
              if ( temp2 > 0) then
              begin
                obsah := copy(radek,temp1+7,length(radek)-22);
                mesta.Items.Add(obsah);
              end;
            end;
            // pozice X
            temp1 := pos('<polohaX>',radek);
            if (temp1 > 0) then
            begin
              temp2 := pos('</polohaX>',radek);
              if ( temp2 > 0) then
              begin
                obsah := copy(radek,temp1+9,length(radek)-26);
                posX.Items.Add(obsah);
              end;
            end;
            // pozice Y
            temp1 := pos('<polohaY>',radek);
            if (temp1 > 0) then
            begin
              temp2 := pos('</polohaY>',radek);
              if ( temp2 > 0) then
              begin
                obsah := copy(radek,temp1+9,length(radek)-26);
                posY.Items.Add(obsah);
                // nakresli prave nactene mesto
                mapa.Canvas.Rectangle(strtoint(posX.Items[aktualne]) + 100,strtoint(posY.Items[aktualne]) + 100,strtoint(posX.Items[aktualne]) + 105,strtoint(posY.Items[aktualne]) + 105);
                aktualne := aktualne + 1;
              end;
            end;

            // CESTY MEZI MESTY
            temp1 := pos('<z>',radek);
            if (temp1 > 0) then
            begin
              temp2 := pos('</z>',radek);
              if ( temp2 > 0) then
              begin
                obsah := copy(radek,temp1+3,length(radek)-14);
                cestaz.Items.Add(obsah);
              end;
            end;

            temp1 := pos('<do>',radek);
            if (temp1 > 0) then
            begin
              temp2 := pos('</do>',radek);
              if ( temp2 > 0) then
              begin
                obsah := copy(radek,temp1+4,length(radek)-16);
                cestado.Items.Add(obsah);
              end;
            end;

            temp1 := pos('<vzdalenost>',radek);
            if (temp1 > 0) then
            begin
              temp2 := pos('</vzdalenost>',radek);
              if ( temp2 > 0) then
              begin
                obsah := copy(radek,temp1+12,length(radek)-32);
                cestavzdalenost.Items.Add(obsah);
              end;
            end;

            temp1 := pos('<prumernaRychlost>',radek);
            if (temp1 > 0) then
            begin
              temp2 := pos('</prumernaRychlost>',radek);
              if ( temp2 > 0) then
              begin
                obsah := copy(radek,temp1+18,length(radek)-44);
                cestarychlost.Items.Add(obsah);
                cesty.Canvas.MoveTo(PoziceMestaX(cestaz.Items[aktualnecesta])+100,PoziceMestaY(cestaz.Items[aktualnecesta])+100);
                cesty.Canvas.lineto(PoziceMestaX(cestado.Items[aktualnecesta])+100,PoziceMestaY(cestado.Items[aktualnecesta])+100);

                aktualnecesta := aktualnecesta + 1;
              end;
            end;


            // vymaze radek po dokonceni operace s nim
            radek := '';
          end else begin
            // prida nasledujici znak z bufferu do radky
            radek := radek + buff[cyklus];
         end;
        end;
    until (konec = true);
      CloseFile(soubor);
   end else begin
      // konec aplikace - nebyla zvolena mapa

      MessageDlg('Pro spusteni je nutne vybrat soubor se schematem mapy!'+char(13)+'Aplikace se nyni ukonci!',mtError,[mbOK],0);
      Application.Terminate;
   end;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  // nastavi zobrazovani cest
  If (CheckBox1.Checked = true) then
  begin
    cesty.Visible := true;
  end else begin
    cesty.Visible := false;
  end;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  // zobrazi odladovaci informace
  If (CheckBox2.Checked = false) then
  begin
    cestado.Visible:=false;
    cestaz.Visible:=false;
    cestarychlost.Visible:=false;
    cestavzdalenost.Visible:=false;
    mesta.Visible:=false;
    posX.Visible:=false;
    posY.Visible:=false;
  end else begin
    cestado.Visible:=true;
    cestaz.Visible:=true;
    cestarychlost.Visible:=true;
    cestavzdalenost.Visible:=true;
    mesta.Visible:=true;
    posX.Visible:=true;
    posY.Visible:=true;
  end;
end;

end.
